'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Disposable = exports.Disposable = function () {
  function Disposable(block) {
    _classCallCheck(this, Disposable);

    if (!block) {
      throw new Error('A Disposable must be created with a dispose callback');
    }
    this.block = block;
  }

  _createClass(Disposable, [{
    key: 'dispose',
    value: function dispose() {
      if (this.block) {
        this.block();
        delete this.block;
      }
    }
  }]);

  return Disposable;
}();

var CompositeDisposable = exports.CompositeDisposable = function (_Disposable) {
  _inherits(CompositeDisposable, _Disposable);

  function CompositeDisposable() {
    var disposables = arguments.length <= 0 || arguments[0] === undefined ? [] : arguments[0];

    _classCallCheck(this, CompositeDisposable);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(CompositeDisposable).call(this, function () {
      for (var i = 0; i < _this.disposables.length; i++) {
        var disposable = _this.disposables[i];
        disposable.dispose();
      }
    }));

    _this.disposables = disposables;
    return _this;
  }

  _createClass(CompositeDisposable, [{
    key: 'add',
    value: function add(disposable) {
      this.disposables.push(disposable);
    }
  }, {
    key: 'remove',
    value: function remove(disposable) {
      var index = this.disposables.indexOf(disposable);

      if (index !== -1) {
        this.disposables.splice(index, 1);
      }
    }
  }]);

  return CompositeDisposable;
}(Disposable);

var DisposableEvent = exports.DisposableEvent = function (_Disposable2) {
  _inherits(DisposableEvent, _Disposable2);

  function DisposableEvent(target, event, listener) {
    _classCallCheck(this, DisposableEvent);

    var events = event.split(/\s+/g);

    if (typeof target.addEventListener === 'function') {
      var _this2 = _possibleConstructorReturn(this, Object.getPrototypeOf(DisposableEvent).call(this, function () {
        return events.forEach(function (e) {
          return target.removeEventListener(e, listener);
        });
      }));

      events.forEach(function (e) {
        return target.addEventListener(e, listener);
      });
    } else if (typeof target.on === 'function') {
      var _this2 = _possibleConstructorReturn(this, Object.getPrototypeOf(DisposableEvent).call(this, function () {
        return events.forEach(function (e) {
          return target.off(e, listener);
        });
      }));

      events.forEach(function (e) {
        return target.on(e, listener);
      });
    }
    return _possibleConstructorReturn(_this2);
  }

  return DisposableEvent;
}(Disposable);